//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit3.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm3 *Form3;
//---------------------------------------------------------------------------
__fastcall TForm3::TForm3(TComponent* Owner)
  : TForm(Owner)
{
  IsShown=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm3::CancelButtonClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::OKButtonClick(TObject *Sender)
{
  int _MinesPercent, _wh;
  bool IsOK=true;
  try
  {
    _MinesPercent = PercentEdit->Text.ToInt();
  }
  catch (...)
  { IsOK=false; }
  if (IsOK)
  {
    IsOK = (_MinesPercent>0) && (_MinesPercent<100);
  }
  if (! IsOK)
  {
    Application->MessageBox(PercentLabel->Caption.c_str(),
      Form1->theMsgBadNumber, MB_OK | MB_ICONERROR);
    return; //break dialog cancelling :)
  }
  try
  {
    _wh = SizeEdit->Text.ToInt();
  }
  catch (...)
  { IsOK=false; }
  if (IsOK)
  {
    IsOK = (_wh>10) && (_wh<500);
  }
  if (! IsOK)
  {
    Application->MessageBox(SizeLabel->Caption.c_str(),
      Form1->theMsgBadNumber, MB_OK | MB_ICONERROR);
    return; //break dialog cancelling :)
  }
  //and if they're OK save reg
  if (IsOK)
  {
    Form1->MinesPercent = _MinesPercent;
    Form1->wh = _wh;
    Form1->FillColor = StaticText1->Font->Color;
    Form1->LightColor = StaticText2->Font->Color;
    Form1->DarkColor = StaticText3->Font->Color;
    Form1->BombColor = StaticText4->Font->Color;
    Form1->BoomColor = StaticText5->Font->Color;
    Form1->SaveIni();
  }
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::FormClose(TObject *Sender, TCloseAction &Action)
{
  IsShown=false;  
}
//---------------------------------------------------------------------------
void __fastcall TForm3::FormShow(TObject *Sender)
{
  if (! IsShown)
  {
    IsShown=true;
    //fill form with data
    char The_MinesPercent[10];
    char The_wh[10];
    wsprintf(The_MinesPercent, "%02d", Form1->MinesPercent);
    wsprintf(The_wh, "%d", Form1->wh);
    PercentEdit->Text = The_MinesPercent;
    SizeEdit->Text = The_wh;
    StaticText1->Font->Color = Form1->FillColor;
    StaticText2->Font->Color = Form1->LightColor;
    StaticText3->Font->Color = Form1->DarkColor;
    StaticText4->Font->Color = Form1->BombColor;
    StaticText5->Font->Color = Form1->BoomColor;
  }//end if (! IsShown)
}
//---------------------------------------------------------------------------
void __fastcall TForm3::RestoreButtonClick(TObject *Sender)
{
    //reset form data to defaults
    PercentEdit->Text = "07";
    SizeEdit->Text ="16";
    StaticText1->Font->Color = clSilver;
    StaticText2->Font->Color = clWhite;
    StaticText3->Font->Color = clGray;
    StaticText4->Font->Color = clRed;
    StaticText5->Font->Color = clYellow;
}
//---------------------------------------------------------------------------
void __fastcall TForm3::StaticText1Click(TObject *Sender)
{
  // 1-st color and TEMPLATE
  ColorDialog1->Color = StaticText1->Font->Color;
  if (ColorDialog1->Execute())
  {
    StaticText1->Font->Color = ColorDialog1->Color;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm3::StaticText2Click(TObject *Sender)
{
  ColorDialog1->Color = StaticText2->Font->Color;
  if (ColorDialog1->Execute())
  {
    StaticText2->Font->Color = ColorDialog1->Color;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm3::StaticText3Click(TObject *Sender)
{
  ColorDialog1->Color = StaticText3->Font->Color;
  if (ColorDialog1->Execute())
  {
    StaticText3->Font->Color = ColorDialog1->Color;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm3::StaticText4Click(TObject *Sender)
{
  ColorDialog1->Color = StaticText4->Font->Color;
  if (ColorDialog1->Execute())
  {
    StaticText4->Font->Color = ColorDialog1->Color;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm3::StaticText5Click(TObject *Sender)
{
  ColorDialog1->Color = StaticText5->Font->Color;
  if (ColorDialog1->Execute())
  {
    StaticText5->Font->Color = ColorDialog1->Color;
  }
}
//---------------------------------------------------------------------------

